#!/bin/bash

PATH=/bin:/usr/bin:/usr/sbin:/fabos/bin:/fabos/link_bin:/fabos/sbin:/fabos/rbin:

# Exported FOS roles for getting into proper logical switch instances when needed.
export CHASSIS_ROLEID=0
export ROLE_ID=root

#blade id's from /proc/fabos/blade/<slot>/info
AWING_ID=213
HARPOON_ID=186
DART_ID=225
DARTx86_ID=228

# formatting
SINGLE_LINE="--------------------------------------------------------------------------------"
DOUBLE_LINE="================================================================================"

# global input vars
SLOT=0
DPID=0
FNAME=""
BLADE_ID=0
INIT_STRING=""
GEID=""
LOGMSG=""
ESMDBGCMD="dbgcmd"      # default to everything until we know the slot/dp
MY_SWITCHID=$FABOS_SWITCHNO

# task spcific vars
DO_INIT=0
DO_FIN=0
DO_POOLS=0
DO_AURAS=0
DO_DRAM2=0
DO_PKO=0
DO_SSO=0
DO_FPGA=0
DO_DPFLOW=0
DO_TUNNEL=0
DO_GE=0
DO_CLIB=0
DO_LSMGLBL=0
DO_LSMFLOW=0
DO_BCM=0
DO_TCPWAN=0
DO_TCPLAN=0
DO_FTNL=0
DO_EMUL=0
DO_LOGMSG=0


# BCM specific input vars
BCMID=""
BCM_OUTLOG=/tmp/epmbcm.outlog.$$
BCM_INLOG=/tmp/epmbcm.inlog.$$
BCM_PTOTAL=0
#CLIHISTORY=( NONE )
#CLILIST=1
#core_filename=$1
bcm_counter=0

bcm_clean()
{
	rm $BCM_OUTLOG 2>/dev/null
	rm $BCM_INLOG 2>/dev/null
}

bcm_comm(){
	#echo "$1" >&2
	echo "$1" >&4
	echo "$1"  2>/dev/null
	ret=$?
	#Check the status for write error for broken pipe
	if [ $ret -ne 0  ]
	then
		echo "Exit as reader has terminated -$ret" >&4
		exit
	fi
}

bcm_reader(){
	option=${1}
	check_delayed=0
	PTOTAL_ORIG=$BCM_PTOTAL
	while [ 1 ]
	do
		TOTAL=`cat ${BCM_OUTLOG} |wc -l`

		if [ $BCM_PTOTAL -lt  $TOTAL ]
		then
			DIFF=`expr $TOTAL - $BCM_PTOTAL`
			if [ "x$option" != "xdumb" ]
			then
				head -${TOTAL} ${BCM_OUTLOG} | tail -${DIFF} >&2
			fi
			BCM_PTOTAL=${TOTAL}
			if [ `head -${TOTAL} ${BCM_OUTLOG} | tail -1 |grep "BCM\..>"  | sed 's/[\t\ ]//g'|wc -c ` -lt 3 ]
			then
				sleep 1
			fi
		else

			if [ ${TOTAL} -gt 1 -a `tail -1 ${BCM_OUTLOG}|grep "BCM\..>"  | sed 's/[\t\ ]//g'|wc -c ` -lt 3 ]
			then
#				enable these lines for hung UI troubleshooting
#				tail -1 ${BCM_OUTLOG} >&2
#				tail -1 ${BCM_OUTLOG}|grep "BCM\..>" >&2
#				tail -1 ${BCM_OUTLOG}|grep "BCM\..>"  | sed 's/[\t\ ]//g' >&2
#				tail -1 ${BCM_OUTLOG}|grep "BCM\..>"  | sed 's/[\t\ ]//g'|wc -c >&2

				sleep 1
			fi
			if [ ${check_delayed} -lt  3 ]
			then
				check_delayed=`expr ${check_delayed} + 1`
				continue
			fi
			DIFF=`expr $TOTAL - $PTOTAL_ORIG`
			date >&4
			bcm_receiver "head -${TOTAL} ${BCM_OUTLOG} | tail -${DIFF}"
			return
		fi

	done

}

bcm_writer(){
    #not needed for bcm no wrapper shell interface
	#instead use counter to switch command

	#read command
	bcm_counter=`expr $bcm_counter + 1`
}

bcm_cli_prompt(){
	 echo -en "$cmd_prompt>" >&2
}

bcm_cli_parser(){

	#if [ "x$command" == "xq" -o "x$command" == "xquit" ]
	#then
	# 	echo -en "press y to exit" >&2
	#	$cmd_caller
	#	if [ "x$command" == "xy" -o "x$command" == "xyes" ]
	#	then

	#		$cmd_exec  "quit"
	#		echo -en "$cmd_prompt> exiting ...\r" >&2
	#		exit
	#	else
	#		continue
	#	fi
	#elif [ "`echo $command |awk {' print $1 '}`" == "XM"  ]
	#then
	#	newcommand=`echo $command |sed 's/XM//g'`
	#	$newcommand
	#else
		$bcm_cmd_exec  "${bcm_command}"
	#fi
}

bcm_receiver(){
	bcm_logcommand=${1}
	if [ "$bcm_cb_receiver" != "NULL" ]
	then
		$bcm_cb_receiver "${bcm_logcommand}"
	fi
}


bcm_command_executer()
{
	#LIST ALL BCM COMMANDS
	#=============================
	BCMCMDS[0]="$BCMID:"
	BCMCMDS[1]='show c'
	BCMCMDS[2]='quit'
	bcm_reader

	if [ $bcm_counter -gt 2 ]; then
		return
	fi

	while [ 1 ]
	do
	    #set the BCM shellexecution command without the reader call implicitly
		bcm_command=${BCMCMDS[$bcm_counter]}
		bcm_command_loop
	done
}

bcm_program_default(){
	BCM_ARGS=( bcm_comm  bcm_writer	bcm_reader  bcm_command  bcm_cli_parser mgdb )
	BCM_PARGS=( NULL	NULL )
	BCM_PROGRAM_COUNT=0
	BCM_PROGRAM_INDEX=0
	BCM_PROGRAMMED=bcm_driver_command
	bcm_cb_receiver=NULL
	bcm_cmd_exec=${BCM_ARGS[0]}
	cmd_caller=${BCM_ARGS[1]}
	cmd_cb=${BCM_ARGS[2]}
	cmd_args=${BCM_ARGS[3]}
	cmd_parse=${BCM_ARGS[4]}
	cmd_prompt=${BCM_ARGS[5]}

}


bcm_driver_command(){

	count=${#BCM_ARGS[@]}
	if [  $count -ne 6 ]
	then
			 echo -en "Incorrect count\r" >&2
			 return
	fi

	$cmd_caller
	$cmd_parse
	$cmd_cb

}

bcm_command_loop(){
	${BCM_PROGRAMMED}
}

bcm_cmds(){
	rm ${BCM_OUTLOG} >/dev/null 2>&1
	exec 3<> ${BCM_INLOG}
	exec 4<> ${BCM_OUTLOG}
	bcm_program_default

	bcm_command_executer |/fabos/libexec/bcm.user.proxy >&4 2>&1
	bcm_clean
}


p_cur_time()
{
	echo "Date `date +\"%F %T.%4N\"`"
}

epm_cmd()
{
	p_cur_time
	echo "Command:$1"
	echo "`$1`"
	echo $SINGLE_LINE
}

# MAIN function
UNKNOWN_ARG=()
while [[ $# -gt 0 ]]
do
	param="$1"
	case $param in
		--initialize)
			DO_INIT=1
			# write passed string, if exists, into INIT_STRING
			while [[ $2 != "--"* ]] && [[ $# -gt 0 ]]; do
				INIT_STRING="$INIT_STRING $2"
				shift # shifs $2->$1 so $3->$2 for new check
			done
			shift # past argument
			;;
		--finalize)
			DO_FIN=1
			shift # past argument
			;;
		--pools)
			DO_POOLS=1
			shift # past argument
			;;
		--auras)
			DO_AURAS=1
			shift # past argument
			;;
		--dram2)
			DO_DRAM2=1
			shift # past argument
			;;
		--pko)
			DO_PKO=1
			shift # past argument
			;;
		--sso)
			DO_SSO=1
			shift # past argument
			;;
		--fpga)
			DO_FPGA=1
			shift # past argument
			;;
		--dp-flow)
			DO_DPFLOW=1
			shift # past argument
			;;
		--tunnel)
			DO_TUNNEL=1
			shift # past argument
			;;
		--ge)
			DO_GE=1
			GEID="$2"
			shift # past argument
			shift # past value
			;;
		--switchid)
			MY_SWITCHID=$2
			shift # past argument
			shift # past value
			;;
		--fid)
			MY_FID=$2
			shift # past argument
			shift # past value
			;;
		--clib)
			DO_CLIB=1
			shift # past argument
			;;
		--lsm-glbl)
			DO_LSMGLBL=1
			shift # past argument
			;;
		--lsm-flow)
			DO_LSMFLOW=1
			shift # past argument
			;;
		--bcm)
			DO_BCM=1
			BCMID=$2
			shift # past argument
			shift # past value
			;;
		--tcp-wan)
			DO_TCPWAN=1
			shift # past argument
			;;
		--tcp-lan)
			DO_TCPLAN=1
			shift # past argument
			;;
		--ftnl)
			DO_FTNL=1
			shift # past argument
			;;
		--emul)
			DO_EMUL=1
			shift # past argument
			;;
		--slot)
			SLOT=$2
			shift # past argument
			shift # past value
			;;
		--dp)
			DPID=$2
			shift # past argument
			shift # past value
			;;
		--filename)
			FNAME="$2"
			if [ ! -f $FNAME ]; then
				touch $FNAME
			fi
			if [ ! -w $FNAME ]; then
				echo " $FNAME is not writeable, exiting."
				exit 2
			fi
			exec &>>$FNAME
			shift # past argument
			shift # past value
			;;
		--pools)
			DO_POOLS=1
			shift # past argument
			;;
		--log)
			while [[ $2 != "--"* ]] && [[ $# -gt 0 ]]; do
				LOGMSG="$LOGMSG $2"
				shift # shifs $2->$1 so $3->$2 for new check
			done
			DO_LOGMSG=1
			shift # past argument
			;;
		*)    # unknown option
			echo "unknown option:!$1!"
			UNKNOWN_ARG+=("$1") # save it in an array for later
			shift # past argument
			;;
	esac
done

if (( ${#UNKNOWN_ARG[@]} )); then
	echo "ERROR, unknown passed parms:${UNKNOWN_ARG[*]}"
	exit 1 # exit early for now
fi

if test -f /proc/fabos/blade/$SLOT/info; then
	# ref. blade id is defined in linux/include/brocade/swbd.h
	BLADE_ID=`cat /proc/fabos/blade/$SLOT/info | /bin/grep -a bladeId | sed 's/[^0-9]//g'`
	if [ $BLADE_ID -eq 0 ]; then
		echo "ERROR, blade_id was not detected."
		exit 2
	fi
fi

# Once we know the slot and dp-id, we can generate the esm dbgcmd
if [ $SLOT -eq 0 ]; then
	ESMDBGCMD="dbg dp$DPID"
else
	ESMDBGCMD="dbg $SLOT/dp$DPID"
fi

if [ $DO_INIT -eq 1 ]; then
	echo $DOUBLE_LINE
	echo "Start run time: `date +\"%F %T.%4N\"`"
	echo "EPM conifg: $INIT_STRING"
	echo $DOUBLE_LINE
fi

if [ $DO_LOGMSG -eq 1 ]; then
	echo $DOUBLE_LINE
	p_cur_time
	echo "$LOGMSG"
	echo $DOUBLE_LINE
fi

# esmcmd dbgX pools
if [ $DO_POOLS -eq 1 ]; then
	epm_cmd "esmcmd $ESMDBGCMD pools"
fi

# esmcmd dbgX auras (only on awing and later).
if [ $DO_AURAS -eq 1 ]; then
	if [ $BLADE_ID -ne $HARPOON_ID ]; then
		epm_cmd "esmcmd $ESMDBGCMD auras"
	fi
fi

# esmcmd dbgX dram2
if [ $DO_DRAM2 -eq 1 ]; then
	epm_cmd "esmcmd $ESMDBGCMD dram2"
fi

# esmcmd dbgX show_pko_flow
if [ $DO_PKO -eq 1 ]; then
	epm_cmd "esmcmd $ESMDBGCMD show_pko_flow"
fi

# sso_regs (platform dependant)
if [ $DO_SSO -eq 1 ]; then
	p_cur_time
	if [ $BLADE_ID -eq $AWING_ID ]; then
		echo "Command:/usr/bin/rsh dp0 'for i in \`seq 0 7\`; do /usr/bin/oct-linux-csr sso_grp${i}_AQ_cnt; done'"
		/usr/bin/rsh dp0 'for i in `seq 0 7`; do /usr/bin/oct-linux-csr sso_grp${i}_AQ_cnt; done'
	elif [ $BLADE_ID -eq $HARPOON_ID ]; then
		echo "Command:/usr/bin/rsh sl${SLOT}_dp${DPID} 'for i in \`seq 0 7\`; do /usr/bin/oct-linux-csr sso_iq_cnt${i} ; done'"
		/usr/bin/rsh sl${SLOT}_dp${DPID} 'for i in `seq 0 7` ; do /usr/bin/oct-linux-csr sso_iq_cnt${i}; done'
	elif [ $BLADE_ID -eq $DARTx86_ID ]; then
		echo "Unknown sso_regs command for dart"
	else
		echo "Unknown sso_regs for blade id:$BLADE_ID"
	fi
	echo $SINGLE_LINE
	epm_cmd "esmcmd $ESMDBGCMD softsso_que_disp -e"
fi

# XMC/EMC backend counters
if [ $DO_FPGA -eq 1 ]; then
	p_cur_time
	if [ $BLADE_ID -eq $AWING_ID ]; then
		/usr/bin/rsh dp0 'for i in `ls /proc/extn/bzka/emc*`; do echo "Filename:${i}" ; cat ${i}; echo ""; done'
		/usr/bin/rsh dp0 'for i in `ls /proc/extn/bzka/xmc*`; do echo "Filename:${i}" ; cat ${i}; echo ""; done'
	elif [ $BLADE_ID -eq $HARPOON_ID ]; then
		/usr/bin/rsh sl${SLOT}_dp${DPID} 'for i in `ls /proc/extn/blzr/emc*`; do echo "Filename:${i}" ; cat ${i}; echo"" ; done'
		/usr/bin/rsh sl${SLOT}_dp${DPID} 'for i in `ls /proc/extn/blzr/xmc*`; do echo "Filename:${i}" ; cat ${i}; echo"" ; done'
	elif [ $BLADE_ID -eq $DARTx86_ID ]; then
		/usr/bin/rsh dp${DPID} 'for i in `ls /proc/extn/bcstr/emc*`; do echo "Filename:${i}" ; cat ${i}; done'
		/usr/bin/rsh dp${DPID} 'for i in `ls /proc/extn/bcstr/xmc*`; do echo "Filename:${i}" ; cat ${i}; done'
	else G
		echo "Unknown xmc/emc layout for blade id:$BLADE_ID"
	fi
	echo $SINGLE_LINE
fi

#dp flowstats (sx6 only)
if [ $DO_DPFLOW -eq 1 ]; then
	if [ $BLADE_ID -eq $HARPOON_ID ]; then
		p_cur_time
		echo "Command: /usr/bin/rsh sl${SLOT}_dp${DPID} '/fabos/bin/dpflowstats -f all'"
		/usr/bin/rsh sl${SLOT}_dp${DPID} '/fabos/bin/dpflowstats -f all'
		echo $SINGLE_LINE
	else
		echo "dp flow stats only supported on SX6 blade."
	fi
fi

# fciptunnel stats output
if [ $DO_TUNNEL -eq 1 ]; then
	# always set to passed switchid, and set to correct FID if necessary. Takes care of case where default switch
	# does not have default FID value.
	export FABOS_SWITCHNO=$MY_SWITCHID
	if [ -v CURRENT_VF ] && [ $CURRENT_VF -ne $MY_FID ]; then
		export CURRENT_VF=$MY_FID
	fi
	epm_cmd "portshow fciptunnel --all-ls -c --qos --perf --filter -dp $SLOT/dp$DPID"
	epm_cmd "portshow fciptunnel --all-ls -d --filter -dp $SLOT/dp$DPID"
	epm_cmd "portshow fciptunnel --all-ls -cd --ha --qos --tcp --filter -dp $SLOT/dp$DPID"
fi


# clib debug cl stats
if [ $DO_CLIB -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD cl"
fi

# lsm global stats
if [ $DO_LSMGLBL -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD lsmstats"
fi

# lsm debug commands
if [ $DO_LSMFLOW -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD lsmconn -v"
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD lsmconn -pf"
fi

# bcm stats, can take up to 10 seconds for pauses
if [ $DO_BCM -eq 1 ]; then
	p_cur_time
	echo "Command: /fabos/libexec/bcm.user.proxy show counters"
	bcm_cmds
	echo $SINGLE_LINE
fi

# tcp wan stats
if [ $DO_TCPWAN -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD tcpconn -e -wan"
fi

# tcp lan stats
if [ $DO_TCPLAN -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD tcpconn -e -lan"
fi

# ftnl output
if [ $DO_FTNL -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD ftnl all"
fi

# fc emulation cmds
if [ $DO_EMUL -eq 1 ]; then
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD fc bm"
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD fc intf"
	epm_cmd "/fabos/rbin/esmcmd $ESMDBGCMD fc vc"
	epm_cmd "sloterrshow -c 1"
fi

# ge portstatsshow
# this should only be called after all other WAN/LAN options are called.  It switches to the switch/VF index the ge
# port resides in before getting stats.
if [ $DO_GE -eq 1 ]; then
	# verify FABOS_SWITCHNO is set before checking it.
	if [ -v FABOS_SWITCHNO ] && [ $FABOS_SWITCHNO -ne $MY_SWITCHID ]; then
		export FABOS_SWITCHNO=$MY_SWITCHID
		export CHASSIS_ROLEID=0
	fi
	# in non-vf case, CURRENT_VF var is unset, only check for VF id match if var exists.
	# ensures that default base switch 0, if not default VF id, will still work.
	if [ -v CURRENT_VF ] && [ $CURRENT_VF -ne $MY_FID ]; then
		export CURRENT_VF=$MY_FID
	fi
	epm_cmd "portstatsshow $GEID"
fi

# finalize
if [ $DO_FIN -eq 1 ] && [ $FNAME != "" ] && [ -f $FNAME ]; then
	echo $DOUBLE_LINE
	echo "finalizing script, compressing $FNAME"
	gzip $FNAME
	p_cur_time
	echo $DOUBLE_LINE
fi

exit 0
